%[u,w,x,t] = PdeMatlab;
%% Version Nov 21, 2019 (OJ)

function [biomass,water,bout, wout, dboutdx, dwoutdx,bderiv,wderiv, x, EndTime] = Pattern;
clear

%% Parameters


xlength = 1001;
tlength = 1000+1;
EndTime=10^3;
x= linspace(0,10,xlength);
t= linspace(0,EndTime,tlength);
L=2*pi*5; 
Symmetry = 0; 
% Original paramters
k = 0.4;
l = 0.9;
g = 12; 
Db= 1.2;
Dw= 150;
r = 0.7;
e =18.8;
m = 10.5;
P =73.5;%-(2*0.1125);
n = 15;
y= k -1/e; 
% Rescaled parameters
A =0.2* P/m;
a = 0.032;
A = 1.6762
a = 0.000175;
C = 0.3;
D = 0.1;
E = 0.2;
Eps = 0.005;
change = 0;
d0 =  0.3;
d1= 0.1;
d2 =0.2;

d3 =A/P;
aa0 = d0-a*d3*P;
aa1 = d1-d3*P;
aa2 = d3*P+d2;

%bb0 = 0; ww0 = d3*P/d0;

bb1  = 0.5*(-aa1+sqrt(aa1^2-4*aa0*aa2))/aa2;
Symmetry = 0;
L=2*pi*5; %length of interval
Symmetry = 0; 
%
%u0=[0.3487*(tanh(100*x-450)) + 0.3487*(tanh(-100*x+550)); 1/0.18];
%% Function evaluation 

sol = pdepe(Symmetry,@(x,t,u,DuDx) pde(x,t,u,DuDx,Db,Dw,L,A, C,D,E, a, Eps, EndTime,change),@ic,@bc,x,t,odeset('NormControl',1,'AbsTol',10^(-6)));

%Extract solution components from sol.
biomass = sol(:,:,1); %These are only values of the first component of sol at every time
water = sol(:,:,2); %These are only values of the second component of sol at every time
%save('biomasswaterstationaryfront.mat','biomass','water');
u = [biomass,water];



%% Initial conditions

function u0 = ic(x)
% u1=  [load('icbiomassmb.txt')];
%u2 = [load('icwatermb.txt')];
% % 
%u0 = [u1(1,round(x/0.01) + 1);u2(1,round(x/0.01) + 1)];
u0 = [0.3487*(tanh(100*x-850)+1);1/0.18];

end


%% PDE formulation 

function [c,f,s] = pde(x,t,u,DuDx,Db,Dw,L,A, C,D,E, a, Eps, EndTime,change);
Acurrent = 1;
%in case of changing rainfall 
if change == 1;
    clear Acurrent;
    tstop = 4500;
    t1 = EndTime/1000;
    t2 = 5101;
    if t < t1
        Acurrent = A;
    elseif (t >t1 - 1) && (t < tstop)
        Acurrent = A*(1-heaviside(t-t1)*(t-t1)/(EndTime-t1));
    elseif t > tstop - 0.2
        Acurrent = A*(1-heaviside(t-t1)*(tstop-t1)/(EndTime-t1));
    end
end

c = [1;1];
f = [DuDx(1)/L^2; (1/1)*DuDx(2)/L^2];

s= [-u(2)*u(1)^3 + u(2)*u(1)^2 - (1-a*u(2))*u(1) ; Acurrent - u(2) - u(1)*u(2) - u(1)^2*u(2) ]; 
end %pde

%% Boundary conditions 
function [pl,ql,pr,qr] = bc(xl,ul,xr,ur,t);
pl=[0;0];
pr=[0;0];
ql=[1;1];
qr=[1;1];
end %bc



end 
